import { ParameterType, ParameterizedCondition, MutateResultType } from 'formn';
import { Dao } from './dao';
export declare class CRUDService<T extends object> {
    protected dao: Dao<T>;
    constructor(dao: Dao<T>);
    create(model: T): Promise<T>;
    retrieve(cond?: object, params?: ParameterType): Promise<T[]>;
    retrieve(cond: ParameterizedCondition): Promise<T[]>;
    retrieveById(id: number | string | Date): Promise<T>;
    updateModel(model: T): Promise<T>;
    deleteById(id: number | string | Date): Promise<T>;
    delete(cond?: object, params?: ParameterType): Promise<MutateResultType>;
    delete(cond: ParameterizedCondition): Promise<MutateResultType>;
}
