import { DataContext, ParameterType, ParameterizedCondition, EntityType, MutateResultType } from 'formn';
export declare class Dao<T extends object> {
    protected dataContext: DataContext;
    protected Entity: EntityType<T>;
    protected alias: string;
    constructor(dataContext: DataContext, Entity: EntityType<T>, alias: string);
    create(model: T): Promise<T>;
    retrieve(cond?: object, params?: ParameterType): Promise<T[]>;
    retrieve(cond: ParameterizedCondition): Promise<T[]>;
    retrieveById(id: number | string | Date): Promise<T>;
    updateModel(model: T): Promise<T>;
    deleteById(id: number | string | Date): Promise<T>;
    delete(cond?: object, params?: ParameterType): Promise<MutateResultType>;
    delete(cond: ParameterizedCondition): Promise<MutateResultType>;
}
