import { MySQLDataContext, ConnectionOptions, MySQLExecuter, MySQLEscaper, EntityType, Insert, MySQLFromAdapter, MySQLUpdateModel, DeleteModel, MySQLTransactionalDataContext } from 'formn';
import { DefaultDataContext } from './default-data-context';
export declare class DataContextManager extends MySQLDataContext {
    private defaultDataContext;
    private transDataContext;
    constructor(defaultDataContext: DefaultDataContext);
    get dataContext(): MySQLDataContext;
    connect(connOpts: ConnectionOptions): Promise<this>;
    end(): Promise<void>;
    beginTransaction<R>(transFunc: (dc: MySQLTransactionalDataContext) => Promise<R>): Promise<R>;
    rollbackTransaction(): Promise<void>;
    getExecuter(): MySQLExecuter;
    getEscaper(): MySQLEscaper;
    insert<T>(Entity: EntityType<T>, model: T): Insert<T>;
    from<T>(Entity: EntityType<T>, alias?: string): MySQLFromAdapter<T>;
    update<T>(Entity: EntityType<T>, model: T): MySQLUpdateModel<T>;
    delete<T>(Entity: EntityType<T>, model: T): DeleteModel<T>;
}
