"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataContextManager = void 0;
const common_1 = require("@nestjs/common");
const formn_1 = require("formn");
const default_data_context_1 = require("./default-data-context");
let DataContextManager = class DataContextManager extends formn_1.MySQLDataContext {
    constructor(defaultDataContext) {
        super();
        this.defaultDataContext = defaultDataContext;
        this.transDataContext = null;
    }
    get dataContext() {
        return this.transDataContext || this.defaultDataContext;
    }
    connect(connOpts) {
        throw new Error('connect not implemented.');
    }
    end() {
        this.transDataContext = null;
        return this.defaultDataContext.end();
    }
    beginTransaction(transFunc) {
        if (this.transDataContext !== null) {
            return transFunc(this.transDataContext);
        }
        return this.dataContext
            .beginTransaction((transDC) => __awaiter(this, void 0, void 0, function* () {
            this.transDataContext = transDC;
            try {
                const result = yield transFunc(transDC);
                this.transDataContext = null;
                return result;
            }
            catch (err) {
                yield this.rollbackTransaction();
                throw err;
            }
        }));
    }
    rollbackTransaction() {
        const rollbackRes = this.dataContext
            .rollbackTransaction();
        rollbackRes
            .finally(() => this.transDataContext = null);
        return rollbackRes;
    }
    getExecuter() {
        return this.dataContext.getExecuter();
    }
    getEscaper() {
        return this.dataContext.getEscaper();
    }
    insert(Entity, model) {
        return this.dataContext.insert(Entity, model);
    }
    from(Entity, alias) {
        return this.dataContext.from(Entity, alias);
    }
    update(Entity, model) {
        return this.dataContext.update(Entity, model);
    }
    delete(Entity, model) {
        return this.dataContext.delete(Entity, model);
    }
};
DataContextManager = __decorate([
    common_1.Injectable({ scope: common_1.Scope.REQUEST }),
    __metadata("design:paramtypes", [default_data_context_1.DefaultDataContext])
], DataContextManager);
exports.DataContextManager = DataContextManager;
//# sourceMappingURL=data-context-manager.js.map