"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModelArrayTransformerPipe = void 0;
const formn_1 = require("formn");
const bsy_error_1 = require("bsy-error");
class ModelArrayTransformerPipe {
    constructor(entityType) {
        this.entityType = entityType;
    }
    transform(rawEnts, meta) {
        return __awaiter(this, void 0, void 0, function* () {
            const ents = [];
            if (!Array.isArray(rawEnts))
                throw new bsy_error_1.ValidationError('Invalid model type (must be an array).', meta.type);
            const transformer = new formn_1.ModelTransformer();
            for (const rawEnt of rawEnts) {
                const ent = yield transformer.transform(rawEnt, this.entityType);
                ents.push(ent);
            }
            return ents;
        });
    }
}
exports.ModelArrayTransformerPipe = ModelArrayTransformerPipe;
//# sourceMappingURL=model-array-transformer.pipe.js.map