"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModelTransformerPipe = void 0;
const common_1 = require("@nestjs/common");
const formn_1 = require("formn");
const bsy_error_1 = require("bsy-error");
let ModelTransformerPipe = class ModelTransformerPipe {
    transform(value, meta) {
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof value !== 'object' || Array.isArray(value))
                throw new bsy_error_1.ValidationError('Invalid model type (must be an object).', meta.type);
            if (!meta.metatype) {
                console.error('value', value);
                console.error('meta', meta);
                throw new Error('Unknown metatype in ModelTransformerPipe.');
            }
            const transformer = new formn_1.ModelTransformer();
            const ent = yield transformer.transform(value, meta.metatype);
            return ent;
        });
    }
};
ModelTransformerPipe = __decorate([
    common_1.Injectable()
], ModelTransformerPipe);
exports.ModelTransformerPipe = ModelTransformerPipe;
//# sourceMappingURL=model-transformer.pipe.js.map