"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseConditionPipe = void 0;
const common_1 = require("@nestjs/common");
const formn_1 = require("formn");
const bsy_error_1 = require("bsy-error");
let ParseConditionPipe = class ParseConditionPipe {
    transform(value, meta) {
        if (typeof value !== 'string')
            throw new bsy_error_1.ValidationError(`Invalid value type ("${meta.data}" must be a string).`, meta.type);
        try {
            const lexer = new formn_1.ConditionLexer();
            const parser = new formn_1.ConditionParser();
            parser.parse(lexer.parse(value));
            return JSON.parse(value);
        }
        catch (err) {
            throw new bsy_error_1.ValidationError(`"${meta.data}" must contain be a valid Formn condition: ${err.message}`, meta.type);
        }
    }
};
ParseConditionPipe = __decorate([
    common_1.Injectable()
], ParseConditionPipe);
exports.ParseConditionPipe = ParseConditionPipe;
//# sourceMappingURL=parse-condition.pipe.js.map