"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormnConditionValidator = void 0;
const formn_1 = require("formn");
class FormnConditionValidator {
    validate(val) {
        if (val === null || val === undefined)
            return true;
        try {
            const lexer = new formn_1.ConditionLexer();
            const parser = new formn_1.ConditionParser();
            parser.parse(lexer.parse(val));
            return true;
        }
        catch (err) {
            return false;
        }
    }
    getErrorMessage(prop) {
        return `"${prop}" must be a valid Formn condition.`;
    }
}
exports.FormnConditionValidator = FormnConditionValidator;
//# sourceMappingURL=formn-condition-validator.js.map