"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderByTypeValidator = void 0;
const bsy_validation_1 = require("bsy-validation");
class OrderByTypeValidator {
    validate(val) {
        let orders;
        if (val === null || val === undefined)
            return true;
        if (typeof val === 'string') {
            if (!new bsy_validation_1.JSONValidator().validate(val))
                return false;
            orders = JSON.parse(val);
        }
        else
            orders = val;
        if (!Array.isArray(orders))
            return false;
        for (const order of orders) {
            if (typeof order !== 'object')
                return false;
            if (typeof order['property'] !== 'string')
                return false;
            if (typeof order['dir'] !== 'string')
                return false;
            if (order['dir'] !== 'ASC' && order['dir'] !== 'DESC')
                return false;
        }
        return true;
    }
    getErrorMessage(prop) {
        return `"${prop}" must be an OrderByType array ([{property: string, dir: 'ASC' | 'DESC'}]).`;
    }
}
exports.OrderByTypeValidator = OrderByTypeValidator;
//# sourceMappingURL=order-by-type.validator.js.map