"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterTypeValidator = void 0;
const bsy_validation_1 = require("bsy-validation");
class ParameterTypeValidator {
    validate(val) {
        let obj;
        if (val === null || val === undefined)
            return true;
        if (typeof val === 'string') {
            if (!new bsy_validation_1.JSONObjectValidator().validate(val))
                return false;
            obj = JSON.parse(val);
        }
        else {
            obj = val;
            if (typeof obj !== 'object' || Array.isArray(obj))
                return false;
        }
        for (const key in obj) {
            const type = typeof obj[key];
            if (type !== 'boolean' && type !== 'string' && type !== 'number' && obj[key] !== null)
                return false;
        }
        return true;
    }
    getErrorMessage(prop) {
        return `"${prop}" must be an object of primitives (Boolean, Number, String, or null values).`;
    }
}
exports.ParameterTypeValidator = ParameterTypeValidator;
//# sourceMappingURL=parameter-type-validator.js.map