"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseSearchQueryPipe = void 0;
const common_1 = require("@nestjs/common");
const bsy_validation_1 = require("bsy-validation");
const search_query_1 = require("./search-query");
const bsy_error_1 = require("bsy-error");
let ParseSearchQueryPipe = class ParseSearchQueryPipe {
    transform(value, meta) {
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof value !== 'object')
                throw new bsy_error_1.ValidationError('Invalid value type (search query must be an object).', meta.type);
            const validator = new bsy_validation_1.ObjectValidator();
            yield validator
                .validate(value, search_query_1.SearchQuery);
            const search = new search_query_1.SearchQuery();
            if (value.cond !== undefined)
                search.cond = JSON.parse(value.cond);
            if (value.params !== undefined)
                search.params = JSON.parse(value.params);
            if (value.order !== undefined)
                search.order = JSON.parse(value.order);
            if (value.offset !== undefined)
                search.offset = parseInt(value.offset, 10);
            if (value.rowCount !== undefined)
                search.rowCount = parseInt(value.rowCount, 10);
            return search;
        });
    }
};
ParseSearchQueryPipe = __decorate([
    common_1.Injectable()
], ParseSearchQueryPipe);
exports.ParseSearchQueryPipe = ParseSearchQueryPipe;
//# sourceMappingURL=parse-search-query.pipe.js.map