import { ParameterType, ColumnLookup, ParameterizedCondition, OrderByType } from 'formn';
import { SearchDao } from './search-dao';
import { SearchResult } from './search-result';
export declare class SearchService<T extends object> {
    protected dao: SearchDao<T>;
    protected columnLookup: ColumnLookup;
    constructor(dao: SearchDao<T>, columnLookup: ColumnLookup);
    retrieve(offset?: number, rowCount?: number, cond?: object, params?: ParameterType, order?: OrderByType[]): Promise<SearchResult<T>>;
    protected mapCondition(cond?: object, params?: ParameterType): ParameterizedCondition;
    protected mapOrder(orders?: OrderByType[]): OrderByType[];
}
